#include <sys/types.h>
#include <sys/stat.h>
#include <sgtty.h>
#include <signal.h>
#include <stdio.h>

extern char *getenv();
extern char *tgetstr();
extern char *index();

#define  TC_BUFFER  1024	/* Size of termcap(3) buffer	 */

struct sgttyb ttymode;		/* and the terminal modes */
char *SO, *SE, *CD;
char buffer[TC_BUFFER];
char *term;
char clear[30];
char *p = &clear[0];

clscr()
{
   static int flag = 0;

   if (flag == 0)
	{
   	get_termcap();  
	flag = 1;
	}

  printf("%s", clear);
}


get_termcap()
{
  static char termbuf[50];
  extern char *tgetstr(), *getenv();
  char *loc = termbuf;
  char entry[1024];

  
  if ((term = getenv("TERM")) == NULL) {
	Error("$TERM not defined");
  }
  if (tgetent(entry, getenv("TERM")) <= 0) {
        Error("Unknown terminal.");
  }
  if (tgetent(buffer, term) != 1) {
	Error("No termcap definition for $TERM");
  }
  if ((tgetstr("cl", &p)) == NULL) {
	Error("No clear (cl) entry for $TERM");
  }
  SO = tgetstr("so", &loc);
  SE = tgetstr("se", &loc);
  CD = tgetstr("cd", &loc);

  if (CD == (char *) 0) CD = "             \r";

}

Error(str)
char *str;
{
  fprintf(stderr, "clr: %s\n", str);
}
