#include "const.h"
#include <stdio.h>
#include <fcntl.h>

#define TAM_REG_PORT 16

/* La Cola de ports posee una lista de los ports a los cuales hay que mandar los
   datos almacenados en el tableau. Esto se hace de esta forma porque habra
   un unico driver manejando diversos PLCs. Pueden mandarse datos de varias
   posiciones del tableau al mismo port (permitiendo que distintas tareas 
   usen el mismo PLC). Tambien puede haber una misma posicion de la tabla,
   asociada a distintos ports.

   La cola sera administrada en forma FIFO, pero si se quisiera dar determi-
   nada prioridad a algunos de los ports, se podria utilizar algun tipo de
   planificacion, ordenando la cola de acuerdo a ese criterio */

typedef struct cola_ports
  {
	int port;
	int tabla;
   	int indice;
  } Cola_Ports;


get_port(i, port, tabla, indice)
int i, *port, *tabla, *indice;
{
    int lis_ports;
    char buffer[TAM_REG_PORT];
    int no_es_eof, devuelve, err_close;
    long err_seek;

    lis_ports = open("/tmp/list_ports", O_RDONLY);
    if (lis_ports < 0) panico(OPEN_ARCH, "list_ports: lectura");
    err_seek = lseek(lis_ports, (long) (i*TAM_REG_PORT), SEEK_SET);
    if (err_seek < 0) panico(SEEK, "get_port");
    no_es_eof = read(lis_ports, buffer, TAM_REG_PORT);	
    err_close = close(lis_ports); 
    if (err_close < 0) panico (ERROR_CLOSE, "list_ports");

    if (no_es_eof)
     	   {		
	   devuelve = TRUE; 
    	   sscanf(buffer, "%5d%5d%5d", port, tabla, indice);
	   }
    else
	   devuelve = FALSE;

    return(devuelve);    
}

find_port(tabla, indice)
int tabla, indice;
{
   int tabla_reg, indice_reg, i, port;

   for(i=0; get_port(i, &port, &tabla_reg, &indice_reg); i++)
      if((tabla == tabla_reg) && (indice == indice_reg))
  		return(port);

   return(PORT_NO_ASIGNADO);
}

add_port_q(port, tabla, indice)
int port, tabla, indice;
{
   int lis_port;
   char buffer[TAM_REG_PORT];

   lis_port = open("/tmp/list_ports", O_WRONLY|O_APPEND);
   sprintf(buffer, "%5d%5d%5d\n", port, tabla, indice);
   write(lis_port, buffer, sizeof(buffer));
   close(lis_port);
}

guardian(port)
int port;
{
   /* Chequea si el port que quiero usar esta siendo usado o no */
  
   return(FALSE);
}
