#include "const.h"
#include <stdio.h>
#include <fcntl.h>
#include <limits.h>
#define TAM_REG_PROC 36

/* La lista de Procesos contiene el nombre del Tableau al que pertenecen los
datos de cada uno de los procesos, el indice dentro de esa tabla, y las
condiciones de alarma minima y maxima para ese dato */

typedef struct
    {
    char nom_proceso[TAM_NOM];
    char nom_disp[TAM_NOM];
    int tabla;
    int indice;
    } Nodo_Proc;

get_proc(i, tabla, indice, nombre, nom_disp, porc)
int i, *tabla, *indice, *porc; 
char nombre[], nom_disp[];
{
   FILE *lis_pr;
   int no_es_eof, err_seek;

#ifdef COSO1
   printf("get_proc, i %d\n", i);
#endif

   lis_pr = fopen("/tmp/list_proc", "r");
   if (lis_pr == NULL) panico(OPEN_ARCH, "list_proc: lectura");
   err_seek = fseek(lis_pr, (long) i*TAM_REG_PROC, SEEK_SET);
   if (err_seek) panico(SEEK, "List_proc: Obtener_proceso");
   no_es_eof = fscanf(lis_pr, "%10s%10s%5d%5d%5d", nombre, nom_disp, tabla, indice, porc);
   fclose(lis_pr);

   if (no_es_eof != EOF) 
        return(TRUE);
   else
	return(FALSE);
}


add_proc(nom_proc, nom_disp, indice, tabla, porc)
char nom_proc[], nom_disp[]; 
int indice, tabla, porc;
{
   int lis_pr;
   char buffer[TAM_REG_PROC];
  
   sprintf(buffer, "%10s%10s%5d%5d%5d\n", nom_proc, nom_disp, tabla, indice, porc);

   lis_pr = open("/tmp/list_proc", O_WRONLY|O_APPEND|O_CREAT, 0666);
   if (lis_pr < 0) panico(OPEN_ARCH, "List_proc: add_proc"); 
   write(lis_pr, buffer, TAM_REG_PROC);
   close(lis_pr);

#ifdef COSO1
   printf("add_proc, buffer %s\n", buffer);
#endif
}

existe_el_proceso(nom_proc)
char nom_proc[];
{
   int i;
   int d1, d2, d4;    /* dummys */
   char nombre[TAM_NOM], d3[TAM_NOM];

   /*   printf("Nombre ingresado: %s", nom_proc); */

   for (i=0; get_proc(i, &d1, &d2, nombre, d3, d4); i++)
		{
		printf("i=%d, nombre=%s\n", i, nombre);
		if(strcmp(nombre, nom_proc) == 0)
			return(i);
		}
   
   return(MAX_PROC); 
}


exist_disp(nom_disp)
char nom_disp[];
{
   int i;
   int d1, d2, d4;    /* dummys */
   char nombre[TAM_NOM], d3[TAM_NOM];

   for (i=0; get_proc(i, &d1, &d2, d3, nombre, &d4); i++)
		if(strcmp(nombre, nom_disp) == 0)
			return(i);
   
   return(MAX_PROC); 
}


get_info_proc(nombre, disp, tabla, indice, porc)
char nombre[], disp[];
int *tabla, *indice, *porc;
{
   int i;
   char nom_d[TAM_NOM], disp_d[TAM_NOM];

   for(i=0; get_proc(i, tabla, indice, nom_d, disp_d, porc); i++)
	if ((strcmp(nom_d, nombre) == 0) && (strcmp(disp_d, disp) == 0))
		return;
}

porc_act(tabla, indice)
int tabla, indice;
{
   int i, tabla_d, indice_d, porc;
   char n1[TAM_NOM], n2[TAM_NOM];

   for(i=0; get_proc(i, &tabla_d, &indice_d, n1, n2, &porc); i++)
	if ( (tabla == tabla_d) && (indice == indice_d) )
		return porc; 

   return 100;  /* porcentaje maximo */
}
