#include "const.h"
#include <sys/types.h>
#include <fcntl.h>
#include <sgtty.h>

#define CHUNK 1024

set_mode(fd, speed, parity, bits, sgsavep)
int speed;
int parity;
int bits;
struct sgttyb *sgsavep;
{
  /* Set open file fd to RAW mode with the given other modes. If fd is
   * not a tty, this may do nothing but connecting ordinary files as
   * ttys may have some use. */

  struct sgttyb sgtty;
  int tabs;

  sgtty = *sgsavep;
  tabs = sgtty.sg_flags & XTABS;
  if (speed == -1) speed = sgtty.sg_ispeed;
  if (parity == -1) parity = sgtty.sg_flags & (EVENP | ODDP);
  if (bits == -1)
	bits = sgtty.sg_flags & BITS8;	/* BITS8 is actually a mask */
  sgtty.sg_ispeed = speed;
  sgtty.sg_ospeed = speed;
  sgtty.sg_flags = RAW | parity | bits | tabs;
  ioctl(fd, TIOCSETP, &sgtty);
}

int mandar(senial, nro_port, status, valor, tabla)
int senial; 
int nro_port;
short *status;
real *valor;
int tabla;
{
    /* Manda una senial de POLL al PLC numero port, y devuelve el resultado 
       en resp. El estado del poll vuelve en status */

     static int port;
     char buf_valor[20];
     real random();
     
     switch(senial)
	{
	case POLL:
		/*	
		*status = TODO_OK;
               	*valor = random();
 		if (tabla != REAL) *valor = (*valor / 100000) * 100000;
		*/

		/*    Version 2 - trabaja de verdad. */

		port = init_port(nro_port);

 		if (port < 0) 	
			{
			close(port);
			*status = ERR_INIT_PORT;
			return;
			}

		sprintf(buf_valor, "%d", POLL);	
		*status = escribir_port(port, buf_valor);
		if (*status == ERR_TRANS) 
			{
			close(port);
			return;
			}

		*status = leer_port(port, valor);
		if (*status == ERR_TRANS) 
			{
			close(port);
			return;
			}
	
		close(port);
		break;
		

	case SELECT:
		
		port = init_port(nro_port);
 		if (port < 0) 	
			{
			close(port);
			*status = ERR_INIT_PORT;
			return;
			}

		sprintf(buf_valor, "%d", SELECT);	
		*status = escribir_port(port, buf_valor);
		if (*status == ERR_TRANS) 
			{
			close(port);
			return;
			}
	
		sprintf(buf_valor, "%ld\n", *valor);	
		*status = escribir_port(port, buf_valor);
		if (*status == ERR_TRANS) 
			{
			close(port);
			return;
			}

		close(port);
		*status = TODO_OK;
		break;

	} /* switch */
}


init_port(port)
int port;
{ 
  int commfd;
  char nom_port[10];
  char add[2];
  struct sgttyb sgcommfd;

  if (port>1) return(-1); /* para evitar que nadie mande nada por COM2 */

  strcpy(nom_port, "/dev/tty");
  add[0] = port+'0';
  add[1] = '\0';
  strcat(nom_port, add);
  
  commfd = open(nom_port, O_RDWR);
  if (commfd < 0) return(ERR_INIT_PORT);

  ioctl(commfd, TIOCGETP, &sgcommfd);
  set_mode(commfd, -1, -1, -1, &sgcommfd);
  return(commfd);
}


escribir_port(fdport, buffer)
int fdport;
char *buffer;
{
   int i;
   char *p;

   for (p=buffer, i=0; *p != '\0'; p++,i++)
	  (*p) &= 0x7F;

   if ( write(fdport, buffer, i) < 0) 
		return(ERR_TRANS);

   return(TODO_OK);
}

leer_port(fdport, valor)
int fdport;
real *valor;
{
   int buffer[CHUNK];
   int leido;

   leido = read(fdport, buffer, sizeof(buffer));
   sscanf(buffer, "%ld", valor); 
   if (leido == 0) return NADA_QUE_MANDAR;

   return(TODO_OK);
}

real random(void)
{
   static unsigned long int next = 1; 

   next = next * 1031245 + 12345;
   return (next % 600000);  /* Se incluyen cinco ceros */ 
}
