#include "const.h"
#include <stdio.h>
#include <fcntl.h>
#include <sgtty.h>
#define TAM_REG_TABL 17
#define TAM_TO_PLC 29
#define TAM_TO_SUP 29


/* Esta es la definicion del Tableau, que sera utilizado para la coleccion de
datos en tiempo real. Se define un registro del tableau. */

typedef struct tableau
   {
     real valor;
     short estado;
   } Reg_Tabl;


/* Esta es la difinicion de la cola de datos enviados por el Driver al SUP */

typedef struct SUP
   {
	int tabla, indice;
	real valor;
	int error;
	short estado;
   } Nodo_SUP;


/* Esta es la definicion de la cola de datos a ser enviados al PLC */

typedef struct PLC
   {
	int tabla, indice;
	real valor;
	short estado;
   } Nodo_PLC;


inicializa()
{
   /* Esta rutina se llama antes de todas las demas rutinas, y solo una vez.
   Abre las colas y mira las posiciones de memoria reservadas para el SUP.
   Si no pudo hacerlo, devuelve un valor negativo.  */

   pid_t resul_fork;
   void writemem(), panico();
   extern int (*tarea[]) ();  
   extern char *nom_tareas[];
   int nro_tarea;
   int dummy1, dummy2;
   int dummy3, dummy4, dummy5, dummy6;


   dummy1 = creat("/tmp/task_q", 0666);
   dummy2 = creat("/tmp/cola_PLC", 0666);
   dummy6 = creat("/tmp/cola_SUP", 0666);
   close(dummy6);
   close(dummy1);
   close(dummy2);

/* 
   dummy3 = creat("/tmp/list_ports", 0666);
   dummy4 = creat("/tmp/list_proc", 0666);
   dummy5 = creat("/tmp/tableau", 0666);

   close(dummy3);
   close(dummy4);
   close(dummy5);

   init_tableau();
/*

   /* Inicializo Lista de Tareas */
   for(nro_tarea=0; nro_tarea<CANT_TAREAS; nro_tarea++)
	{

#ifdef COSO1
 	printf("Trabajando con tarea nro: %d", nro_tarea);
#endif

	if ( (resul_fork = fork())  == ERROR_FORK)
		panico(ERROR_FORK, "Error al lanzar proceso");
	else
		{

#ifdef COSO1
 		printf("El resultado del fork fue %d \n", resul_fork);
#endif
                
  		if (resul_fork == 0)
		        tarea[nro_tarea]();
		else
			{
#ifdef COSO1
			printf("Sigo ejecutando el padre, porque dio 0 \n");
#endif
			crear_tarea(nro_tarea, resul_fork);
			}
		}
	}
}

be_safe()
{ 
   /* Chequea para ver si el SUP todavia esta ejecutando. Si paro, devuelve
   un valor distinto de cero. Debe llamarse frecuentemente (por lo menos, una
   vez por segundo) */

   int i, ok, verdad = TRUE;  
   time_t *dum1, *dum2;
   pid_t pid;
   char tipo_error[20];

   for (i=0; get_task_q(i, dum1, dum2, &pid); i++)
		{ ok = kill(pid, SIGUSR2);
		  if (ok != 0) verdad = FALSE;
		}
   return verdad;
/*
			{
			sprintf(tipo_error,"Murio el proceso %d", pid);
			panico(KILL, tipo_error);
			exit(-1);
			}
*/
}


void readmem(tabla, indice, valor, estado)
int tabla, indice; 
real *valor; 
short *estado;
{

  /* Lee un valor directamente de las tablas. 
  tabla: un entero correspondiente a una de las tablas;
  indice: un entero correspondiente a la posicion de la tabla
  valor: el valor obtenido de la posicion (si es digital, devuelve 0.0 o 1.0)
  estado: un byte que contiene el status de la variable. 
   */
   
   int tableau; 
   long donde;
   char buffer[TAM_REG_TABL];
   long err_seek;
   int no_es_eof, err_close;

   donde = (long) ((tabla*TAM_TABLEAU+indice)*TAM_REG_TABL);
/*
   printf("Tabla: %d, indice: %d, donde: %ld \n", tabla, indice, donde);
*/

   tableau = open("/tmp/tableau", O_RDONLY);
   if (tableau == -1) panico(OPEN_ARCH, "Readmem: Tableau");

   err_seek = lseek(tableau, donde, SEEK_SET);
   if (err_seek == -1L) panico(SEEK, "Readmem: Tableau");

   no_es_eof = read(tableau, buffer, TAM_REG_TABL);
   if (no_es_eof == EOF) panico (ACCESO_TABL, "Readmem: acceso fuera de limites");

   err_close = close(tableau);
   if (err_close < 0) panico(ERROR_CLOSE, "Readmem: Tableau");

   sscanf(buffer, "%10ld %5d", valor, estado);
}


void writemem(tabla, indice, valor, estado)
int tabla, indice; 
real valor; 
short estado;
{
  /* Escribe un valor directamente en las tablas de memoria. esto es mas
  eficiente que qwrite, sin embargo, como writemem se saltea la cola_to_SUP,
  el valor no esta sujeto a coleccion historica 

  Si el status es <> 0, quiere decir que hubo algun error, o que cambio de
  estado. Por lo tanto, se mantiene el valor antiguo de la tabla: en tal ca-
  so, value puede tener basura porque no se lo considera 

  Si escribimos un valor con un status = ALARMA, significa que hay una
  ALARMA */
 
  int tableau; 
  long donde;
  char buffer[TAM_REG_TABL];
  int err_close, err_write;
  long err_seek;
  short dummy;

  if (estado != TODO_OK)
	readmem(tabla, indice, &valor, &dummy); /* para guardar el valor orig */
  sprintf(buffer, "%10ld %5d\n", valor, estado);
  donde = (long) ((tabla*TAM_TABLEAU+indice)*TAM_REG_TABL);
  

  tableau = open("/tmp/tableau", O_WRONLY);
  if (tableau == -1) panico(OPEN_ARCH, "Writemem: Tableau");

  err_seek = lseek(tableau, donde, SEEK_SET);
  if (err_seek == -1L) panico(SEEK, "Writemem: Tableau ");

  err_write = write(tableau, buffer, TAM_REG_TABL); 
  if (err_write == -1) panico(WRITE, "Writemem: Tableau");

  err_close = close(tableau);
  if (err_close < 0) panico(ERROR_CLOSE, "Writemem: Tableau");

} 

void driv_qwrite(tabla, indice, valor, estado)
int tabla, indice;
real valor;
short estado;
{
   /* Escribe un valor en la Cola_al_PLC, que es la cola que los drivers
   monitorean para cambios que vienen del SUP. Esto no modifica los valo-
   res en las tablas del SUP */

   int cola_to_PLC ;
   char buffer[TAM_TO_PLC];


   cola_to_PLC = open("/tmp/cola_PLC", O_WRONLY|O_APPEND);
   sprintf(buffer,"%5d %5d %10ld %5d\n", tabla, indice, valor, estado);
   write(cola_to_PLC, buffer, TAM_TO_PLC);
   close(cola_to_PLC);
   
}


void qread(i, tabla, indice, valor, estado, error)
int i;
int *tabla, *indice, *error;
real *valor;
short *estado;
{
   /* Trata de leer un valor de la Cola_al_PLC, que es la cola que usa
   el SUP para mandar cambios a los drivers. Por ejemplo, si un operador
   uso el comando CHA, el nuevo valor sera escrito en esta cola. Como lal
   cola lpuede contener mas de un valor, esta funcion deberia ser utilizada
   dentro de un loop que solo salga cuando no haya mas valores. Como los 
   drivers tambien pueden leer esta cola, NO hay que usar qread a menos
   que no haya drivers corriendo en la maquina.

   El parametro error indica el exito o falla de la lectura. Un valor de
   0 indica que fue exitoso, mientras que uno distinto de cero indica una
   falla, presumiblemente porque no hay mas valores en la cola.

   Tomo el primer elemento de la Cola_al_PLC, y se toman sus valores. Avanzo 
   el puntero. Si no hay valores, doy una seal de error */

   int cola_to_PLC, no_es_eof;
   char buffer[TAM_TO_PLC];

   cola_to_PLC = open("/tmp/cola_PLC", O_RDONLY);

#ifdef COSO1
   printf("El handle para cola_to_PLC es %d\n", cola_to_PLC);
#endif

   if (cola_to_PLC < 0) panico(OPEN_ARCH, "Qread: Cola_PLC");

   lseek(cola_to_PLC, (long) i*TAM_TO_PLC, SEEK_SET);
   no_es_eof = read(cola_to_PLC, buffer, TAM_TO_PLC);
   close(cola_to_PLC);

#ifdef COSO1
   printf("El buffer que leyo es: %s\n", buffer);
   printf("no-es-eof = %d\n", no_es_eof);
#endif

   if (no_es_eof)
	{
        sscanf(buffer,"%5d %5d %10ld %5d", tabla, indice, valor, estado);
      	*error  = TODO_OK;
	}
   else
	{
        *tabla = *indice = *estado = 0;
	*valor = 0L;
	*error = NO_HAY_VALORES;
 	cola_to_PLC = creat("/tmp/cola_PLC", 0666); /* Deja la cola vacia */
        close(cola_to_PLC);
	}
}

void qwrite(tabla, indice, valor, estado)
int tabla, indice;
real valor;
short estado;
{
    /* Escribe en el Tableau via la Cola_to_SUP. Esto es menos eficiente
    que writemem, pero fuerza la coleccion historica del valor */

    int cola_to_SUP;
    char buffer[TAM_TO_SUP];

    cola_to_SUP = open("/tmp/cola_SUP", O_WRONLY | O_APPEND);
    if (cola_to_SUP < 0) panico(OPEN_ARCH, "qwrite: Cola_SUP");
	sprintf(buffer,"%5d %5d %10ld %5d\n", tabla, indice, valor, estado);

#ifdef COSO1
 	printf("Va a escribir en cola_SUP el buffer %s", buffer);  
#endif
	write(cola_to_SUP, buffer, TAM_TO_SUP);
	close(cola_to_SUP);
}


void driv_qread(i, tabla, indice, valor, estado, error)
int i;
int *tabla, *indice, *error;
real *valor;
short *estado;
{
   /* Trata de leer un valor de la Cola_al_SUP, que es la cola que usan
   los drivers para mandar cambios al supervisor. 

   El parametro error indica el exito o falla de la lectura. Un valor de
   0 indica que fue exitoso, mientras que uno distinto de cero indica una
   falla, presumiblemente porque no hay mas valores en la cola.

   Tomo el primer elemento de la Cola_al_SUP, y se toman sus valores. Avanzo 
   el puntero. Si no hay valores, doy una seal de error */

   int cola_to_SUP, no_es_eof;
   char buffer[TAM_TO_PLC];

   cola_to_SUP = open("/tmp/cola_SUP", O_RDONLY);
   if (cola_to_SUP < 0) panico(OPEN_ARCH, "driv_qread: Cola_SUP");

   /* printf("Va a ir al elemento %d\n",i); */
   lseek(cola_to_SUP, (long) i*TAM_TO_SUP, SEEK_SET);
   no_es_eof = read(cola_to_SUP, buffer, TAM_TO_SUP);
   close(cola_to_SUP);

#ifdef COSO1
   printf("El buffer que leyo es: %s\n", buffer);
   printf("no-es-eof = %d\n", no_es_eof);
#endif

   if (no_es_eof)
	{
        sscanf(buffer,"%5d %5d %10ld %5d", tabla, indice, valor, estado);
      	*error  = TODO_OK;
	}
   else
	{
        *tabla = *indice = *estado = 0;
	*valor = 0L;
	*error = NO_HAY_VALORES;
 	cola_to_SUP = creat("/tmp/cola_SUP", 0666); /* Deja la cola vacia */
        close(cola_to_SUP);
	}
}


void panico(tipo_error, mensaje)
int tipo_error;
char *mensaje;
{
   extern errno;

	printf("Panico... se cae el sistema \n");
	printf("Error numero: %d.   ", tipo_error);
  	printf("%s \n", mensaje);
	printf("Errno: %d\n", errno);
        shutdown();
	/* El shutdown se hace dependiendo del error */
}


shutdown()
{

   int i, port;
   time_t *d1, *d2;
   pid_t pid;

  	for (i=0; get_task_q(i, d1, d2, &pid); i++)
		kill(pid, SIGKILL);

	for(i=1; i<=4; i++)
		{
		port = init_port(i);
		escribir_port(port, CBREAK);
		}
}


busq_tableau_libre(tabla)
int tabla;
{
    int indice;
    real valor;
    short estado;

	for (indice=0; indice<TAM_TABLEAU ; indice++)
		{
		readmem(tabla, indice, &valor, &estado);

		if (estado == ENTRADA_LIBRE)
			{
			writemem(tabla, indice, 0L, TODO_OK);
			return(indice);
			}
		}

	return(NO_HAY_ESPACIO);
}


init_tableau()     
{
   int i,j;
   void readmem(), writemem();

   for(i=0; i<CANT_TABLEAUX; i++)
	for(j=0; j<TAM_TABLEAU; j++)
		writemem(i, j, 0L, ENTRADA_LIBRE);
}
